%global namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}
%global with_test 0
Name:          deltaspike
Version:       1.2.1
Release:       5%{?dist}
Summary:       Portable CDI extensions
License:       ASL 2.0
URL:           http://deltaspike.apache.org/
Source0:       https://github.com/apache/deltaspike/archive/%{name}-project-%{namedversion}.tar.gz
# Support for servlet 3.1 apis
Patch0:        deltaspike-1.2.1-MockServletContext.patch

BuildRequires: maven-local
BuildRequires: mvn(javax.el:javax.el-api)
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache:apache:pom:)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jcdi_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-validation_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:specs:pom:)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-site-plugin)
# TODO update to 1.2.7
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans:pom:)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans-impl)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans-resource)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans-spi)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.0-api)
BuildRequires: mvn(org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec)
BuildRequires: mvn(org.jboss.weld.se:weld-se-core)
BuildRequires: mvn(org.quartz-scheduler:quartz)

# site plugin runtime deps
BuildRequires: mvn(org.apache.maven.doxia:doxia-integration-tools)
BuildRequires: mvn(org.apache.maven.shared:maven-shared-components:pom:)

%if %with_test
# Test deps
BuildRequires: mvn(asm:asm-commons)
BuildRequires: mvn(javassist:javassist)
BuildRequires: mvn(org.apache.bval:bval-jsr303)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-osgi-locator)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.openwebbeans.arquillian:owb-arquillian-standalone)
BuildRequires: mvn(org.apache.xbean:xbean-finder)
BuildRequires: mvn(org.hamcrest:hamcrest-library)
BuildRequires: mvn(org.jboss.arquillian.junit:arquillian-junit-container)
BuildRequires: mvn(org.jboss.as:jboss-as-arquillian-container-remote)
BuildRequires: mvn(org.jboss.shrinkwrap.descriptors:shrinkwrap-descriptors-impl)
BuildRequires: mvn(org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-impl-maven)
BuildRequires: mvn(org.apache.myfaces.test:myfaces-test20)
BuildRequires: mvn(org.apache.myfaces.core:myfaces-impl-test)

BuildRequires: mvn(org.bsc.maven:maven-processor-plugin)
BuildRequires: mvn(org.hibernate:hibernate-jpamodelgen)
# TODO
# https://bugzilla.redhat.com/show_bug.cgi?id=1208379
BuildRequires: mvn(org.primefaces.extensions:resources-optimizer-maven-plugin)
# 2015-07-29: Retired because it depends on shrinkwrap-resolver which did not...
BuildRequires: mvn(org.jboss.arquillian.container:arquillian-container-test-spi)
BuildRequires: mvn(org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-bom:pom:)

BuildRequires: mvn(org.jboss.shrinkwrap:shrinkwrap-api)
%endif

BuildArch:     noarch

%description
DeltaSpike consist of a number of portable CDI extensions
that provide useful features for Java application developers.

%package core
Summary:       Apache DeltaSpike Core

%description core
Apache DeltaSpike Core APIs and Implementation.

%package cdictrl
Summary:       Apache DeltaSpike ContainerControl

%description cdictrl
This project provides a way to generically run CDI containers 
from inside of unit tests or Java SE applications.

%package modules
Summary:       Apache DeltaSpike Modules

%description modules
Apache DeltaSpike Modules Parent Pom.

%package bean-validation-module
Summary:       Apache DeltaSpike BeanValidation-Module

%description bean-validation-module
Apache DeltaSpike BeanValidation-Module APIs and implementations.

%package data-module
Summary:       Apache DeltaSpike Data-Module

%description data-module
Apache DeltaSpike Data-Module APIs and implementations.

%package jpa-module
Summary:       Apache DeltaSpike JPA-Module

%description jpa-module
Apache DeltaSpike JPA-Module APIs and implementations.

%package jsf-module
Summary:       Apache DeltaSpike JSF-Module

%description jsf-module
Apache DeltaSpike JSF-Module APIs and implementations.

%package partial-bean-module
Summary:       Apache DeltaSpike Partial-Bean-Module

%description partial-bean-module
Apache DeltaSpike Partial-Bean-Module APIs and implementations.

%package scheduler-module
Summary:       Apache DeltaSpike Scheduler-Module

%description scheduler-module
Apache DeltaSpike Scheduler-Module APIs and implementations.

%package security-module
Summary:       Apache DeltaSpike Security-Module

%description security-module
Apache DeltaSpike Security-Module APIs and implementations.

%package servlet-module
Summary:       Apache DeltaSpike Servlet-Module

%description servlet-module
Apache DeltaSpike Servlet-Module APIs and implementations.

%package test-control-module
Summary:       Apache DeltaSpike Test-Control-Module

%description test-control-module
Apache DeltaSpike Test-Control-Module APIs and implementations.

%package test-utils
Summary:       Apache DeltaSpike Test-Utils

%description test-utils
This package contains our Test Categories and
other useful stuff for running our tests.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{name}-project-%{namedversion}
# Cleanup
find . -name "*.class" -print -delete
find . -name "*.jar" -print -delete
mv %{name}/* .
rm -r %{name}

%patch0 -p1

%pom_disable_module checkstyle-rules
%pom_disable_module examples

# org.apache.openejb:openejb-core 4.0.0-beta-2
%pom_disable_module impl-openejb cdictrl
# package org.apache.myfaces.test.mock does not exist
# package org.apache.myfaces.mc.test.core.runner
%pom_disable_module impl modules/test-control

%pom_remove_plugin :maven-checkstyle-plugin parent

%pom_remove_plugin -r :maven-dependency-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin :maven-processor-plugin modules/data/impl
# TODO
%pom_remove_plugin -r :resources-optimizer-maven-plugin
# Don't work with bundle-plugin 2.5.4
%pom_xpath_remove "pom:plugin[pom:artifactId = 'maven-bundle-plugin']/pom:configuration" parent

# Retired
%pom_remove_dep -r :shrinkwrap-resolver-bom
%pom_remove_dep -r :arquillian-bom parent
%pom_remove_dep -r :arquillian-container-test-spi
rm -r test-utils/src/main/java/org/apache/deltaspike/test/arquillian
%pom_remove_dep -r :shrinkwrap-api
rm -r test-utils/src/main/java/org/apache/deltaspike/test/utils/ShrinkWrapArchiveUtil.java

%pom_change_dep -r :geronimo-interceptor_1.1_spec org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec
%pom_change_dep -r :geronimo-atinject_1.0_spec javax.inject:javax.inject
%pom_change_dep -r :geronimo-jpa_2.0_spec org.hibernate.javax.persistence:hibernate-jpa-2.0-api
%pom_change_dep -r :myfaces-api org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec
%pom_change_dep -r :geronimo-servlet_2.5_spec javax.servlet:javax.servlet-api:3.1.0
%pom_change_dep -r :geronimo-servlet_3.0_spec javax.servlet:javax.servlet-api:3.1.0
%pom_change_dep -r :geronimo-el_2.2_spec javax.el:javax.el-api:3.0.0

%mvn_package ":%{name}-project" %{name}
%mvn_package ":parent*" %{name}
%mvn_package ":*core*" core
# unavailable deps for: impl-openejb
%mvn_package ":*cdictrl*" cdictrl
%mvn_package ":modules-project" modules
%mvn_package ":*bean-validation*" bean-validation-module
%mvn_package ":*data*" data-module
%mvn_package ":*jpa*" jpa-module
%mvn_package ":*jsf*" jsf-module
%mvn_package ":*partial*" partial-bean-module
%mvn_package ":*scheduler*" scheduler-module
%mvn_package ":*security*" security-module
%mvn_package ":*servlet*" servlet-module
%mvn_package ":*test-control*" test-control-module
%mvn_package ":test-utils" test-utils

%if %with_test
%mvn_package :::tests: test-utils
%endif

%build

# No test deps
%mvn_build \
%if !%with_test
 -f
%endif

%install
%mvn_install

%files -f .mfiles-%{name}
%doc README.md readme/*-%{namedversion}.txt
%license LICENSE NOTICE

%files core -f .mfiles-core
%license LICENSE NOTICE

%files cdictrl -f .mfiles-cdictrl
%license LICENSE NOTICE

%files modules -f .mfiles-modules
%license LICENSE NOTICE

%files bean-validation-module -f .mfiles-bean-validation-module
%license LICENSE NOTICE

%files data-module -f .mfiles-data-module
%doc modules/data/README.adoc
%license LICENSE NOTICE

%files jpa-module -f .mfiles-jpa-module
%license LICENSE NOTICE

%files jsf-module -f .mfiles-jsf-module
%license LICENSE NOTICE

%files partial-bean-module -f .mfiles-partial-bean-module
%license LICENSE NOTICE

%files scheduler-module -f .mfiles-scheduler-module
%license LICENSE NOTICE

%files security-module -f .mfiles-security-module
%license LICENSE NOTICE

%files servlet-module -f .mfiles-servlet-module
%license LICENSE NOTICE

%files test-control-module -f .mfiles-test-control-module
%license LICENSE NOTICE

%files test-utils -f .mfiles-test-utils
%license LICENSE NOTICE

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jul 30 2015 gil cattaneo <puntogil@libero.it> 1.2.1-4
- disable arquillian support
- use servlet 3.1 apis only

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Feb 16 2015 gil cattaneo <puntogil@libero.it> 1.2.1-2
- resolve Non-resolvable import POM

* Mon Feb 02 2015 gil cattaneo <puntogil@libero.it> 1.2.1-1
- update to 1.2.1

* Mon Sep 30 2013 gil cattaneo <puntogil@libero.it> 0.5-1
- update to 0.5

* Fri Jun 14 2013 gil cattaneo <puntogil@libero.it> 0.4-1
- update to 0.4

* Sat May 25 2013 gil cattaneo <puntogil@libero.it> 0.3-1
- initial rpm
